#ifndef permute_h
#define permute_h

/*
    Return the number of permutations of n elements, where
    d of the elements are identical.
*/
extern unsigned int npermutations(unsigned int n, unsigned int d);

/*
    Copy n characters from in to out, in permutation number p.
    Assume that the first d characters of in are identical.
*/
extern void permute(char *out, const char *in, unsigned int n,
    unsigned int p, unsigned int d);

#endif
